#version 120

uniform sampler2D DiffuseSampler;
uniform sampler2D PrevSampler;
uniform sampler2D FPSSampler;

uniform float Time;
varying vec2 texCoord;
varying vec2 oneTexel;

uniform vec2 InSize;

const float PI = 3.1415926535897932384626433832795;

int getFrame(sampler2D sampler, float xpos) {
	ivec4 left_test = ivec4(-1, -1, -1, -1);
	ivec4 middle_test = ivec4(-1, -1, -1, -1);
	ivec4 right_test = ivec4(-1, -1, -1, -1);
	for (int i = 0; i < 4; i++) {
		vec4 testTexel = texture2D(sampler, vec2(xpos + oneTexel.x * ((i + 1) * 3 - 1), 0.0));
		if (testTexel.g < 0.003 && testTexel.b < 0.003) {
			if (testTexel.r > 0.984)
				left_test[i] = 0;
			else if (testTexel.r > 0.976)
				left_test[i] = 1;
			else
				return -1;
		}
		else {
			return -1;
		}
	}
	for (int i = 0; i < 4; i++) {
		vec4 testTexel = texture2D(sampler, vec2(xpos + oneTexel.x * ((i + 5) * 3 - 1), 0.0));
		if (testTexel.g < 0.003 && testTexel.b < 0.003) {
			if (testTexel.r > 0.984)
				middle_test[i] = 0;
			else if (testTexel.r > 0.976)
				middle_test[i] = 1;
			else
				return -1;
		}
		else {
			return -1;
		}
	}
	for (int i = 0; i < 4; i++) {
		vec4 testTexel = texture2D(sampler, vec2(xpos + oneTexel.x * ((i + 9) * 3 - 1), 0.0));
		if (testTexel.g < 0.003 && testTexel.b < 0.003) {
			if (testTexel.r > 0.984)
				right_test[i] = 0;
			else if (testTexel.r > 0.976)
				right_test[i] = 1;
			else
				return -1;
		}
		else {
			return -1;
		}
	}
	
	return left_test[0] * 2048 + left_test[1] * 1024 + left_test[2] * 512 + left_test[3] * 256 + middle_test[0] * 128 + middle_test[1] * 64 + middle_test[2] * 32 + middle_test[3] * 16 + right_test[0] * 8 + right_test[1] * 4 + right_test[2] * 2 + right_test[3];
}

int imod(int num, int m) {
	return num - (num / m * m);
}

void recordColor(int num, float xpos) {
	if (texCoord.x <= xpos + oneTexel.x * 3) {
		if (num / 2048 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 6) {
		if (imod(num, 2048) / 1024 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 9) {
		if (imod(num, 1024) / 512 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 12) {
		if (imod(num, 512) / 256 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 15) {
		if (imod(num, 256) / 128 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 18) {
		if (imod(num, 128) / 64 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 21) {
		if (imod(num, 64) / 32 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 24) {
		if (imod(num, 32) / 16 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 27) {
		if (imod(num, 16) / 8 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 30) {
		if (imod(num, 8) / 4 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else if (texCoord.x <= xpos + oneTexel.x * 33) {
		if (imod(num, 4) / 2 == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
	else {
		if (imod(num, 2) == 1) 
			gl_FragColor = vec4(0.98, 0.0, 0.0, 1.0);
		else 
			gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
}

void slash(int frame, vec4 CurrTexel) {
	float tick = frame / 60.0;
	
	float v;
	float mask = 0.0;
	float dist = 0.0;
	if (tick < 0.5) {
		v = (-2 * tick + 1) / 120;
		dist = (-2 * tick + 2) * tick / 4;
	}
	else {
		v = (4 * tick - 2) / 120;
		dist = 0.125 + (4 * tick - 2) * (tick - 0.5) / 4;
		mask = pow((tick - 0.5) * 2, 2);
	}
	
	vec4 color;
	if (texCoord.y < 0.5) {
		if (texCoord.x > dist)
			color = texture2D(PrevSampler, vec2(texCoord.x - v, texCoord.y));
		else
			color = vec4(CurrTexel.rgb, 1.0);
	}
	else {
		if (texCoord.x < (1 - dist))
			color = texture2D(PrevSampler, vec2(texCoord.x + v, texCoord.y));
		else
			color = vec4(CurrTexel.rgb, 1.0);
	}
	
	gl_FragColor = vec4(color.r * (1 - mask) + mask, color.g * (1 - mask) + mask, color.b * (1 - mask) + mask, 1.0);
}

void main() {
	vec4 PrevTexel = texture2D(PrevSampler, texCoord);
	gl_FragColor = vec4(PrevTexel.rgb, 1.0);
	float fps_rate = getFrame(FPSSampler, oneTexel.x * 72) / 0.8 / 60;
	if (fps_rate < 0)
		fps_rate = 1.0;
	
	vec4 judgeTexel = texture2D(DiffuseSampler, vec2(0.5, 0.5));
	if (judgeTexel.r > 0.976 && judgeTexel.g < 0.003 && judgeTexel.b < 0.003) {
		if (texCoord.y <= oneTexel.y && texCoord.x <= oneTexel.x * 36)
			recordColor(0, 0.0);
		else
			gl_FragColor = vec4(PrevTexel.rgb, 1.0);
	}
	else {
		int frame = getFrame(PrevSampler, 0.0);
		vec4 CurrTexel = texture2D(DiffuseSampler, texCoord);
		
		if (frame >= 0) {
			if (frame < 61 * fps_rate) {
				if (texCoord.y <= oneTexel.y && texCoord.x <= oneTexel.x * 36)
					recordColor(frame + 1, 0.0);
				else if (frame > 0)
					slash(int(frame / fps_rate), CurrTexel);
				else
					gl_FragColor = vec4(CurrTexel.rgb, 1.0);
			}
			else {
				gl_FragColor = vec4(CurrTexel.rgb, 1.0);
			}
		}
		else {
			if (CurrTexel.r > 0.3 && CurrTexel.g < 0.03 && CurrTexel.b < 0.03)
				gl_FragColor = vec4(PrevTexel.rgb, 1.0);
			else
				gl_FragColor = vec4(CurrTexel.rgb, 1.0);
		}
	}
}
